#include <Sensor TCS3472 RGB.h>

#FUSES NOMCLR

#use i2c(Master, Fast, sda=PIN_B0, scl=PIN_B1, force_sw, stream=OLED_stream)//parametros I2C
#use i2c(Master, Fast, sda=PIN_B0, scl=PIN_B1, force_sw, stream=TCS34725_stream)//parametros I2C

#define SH1106_128_64 //DEFINE EL MODELO DE LA PANTALLA OLED
//#define SSD1306_128_64

#include "OLED_I2C.c" //libreria oled I2C
#include "TCS34725.c"

#define ajs input(PIN_D0)
#define mas input(PIN_D1)
#define menos input(PIN_D2)


float rojo, verde, azul;
char texto[128];
int8 x;
int8 color;


void masmenos();

void OLED()
{
   sprintf(texto,"R: %f",rojo);
   OLED_DrawText(1,1,texto,2);
   
   sprintf(texto,"G: %f",verde);
   OLED_DrawText(1,16,texto,2);
   
   sprintf(texto,"B: %f",azul);
   OLED_DrawText(1,32,texto,2);
   
   switch (color)
   {
      case 1:
         sprintf(texto,"ROJO ");
         OLED_DrawText(40,48,texto,2);
      break;
      
      case 2:
         sprintf(texto,"VERDE");
         OLED_DrawText(40,48,texto,2);
      break;
      
      case 3:
         sprintf(texto,"AZUL ");
         OLED_DrawText(40,48,texto,2);
      break;
      
      default:
         sprintf(texto,"     ");
         OLED_DrawText(40,48,texto,2);
      break;  
   }
   

   OLED_Display();//Muestra la informacion en la pantalla

}


void main()
{
   TCS34725_init();

   OLED_Begin();
   OLED_ClearDisplay();
   
   x = read_EEPROM (1);//(n de registro)
   while(TRUE)
   {
      getRGB(&rojo, &verde, &azul);//datos del sensor 
      
        
      if (rojo>=x || verde>=x || azul>=x)
      {
         if (rojo>verde && rojo>azul)
         {
            color=1;//rojo
         }else if (verde>rojo && verde>azul)
         {
            color=2;//verde      
         }else
         {
            color=3;//azul      
         }
      }else
      {
         color=0;    
      }
      
      OLED();
      
      while(ajs)//boton de ajuste para cambiar x
      {
         delay_ms(10);
         if (!ajs)
         {
            masmenos();
         }
      } 
      //TODO: User Code
   }

}


void oled_ajuste()
{
   sprintf(texto,"Max=%03u",x);
   OLED_DrawText(1,1,texto,2);
   OLED_Display();//Muestra la informacion en la pantalla
}


void masmenos()
{  
   OLED_ClearDisplay(); 
   
   while (true){
   
      while(mas)//boton de ms
      {
         delay_ms(10);
         if(!mas)
         {
            x++;
         }
      }
   
      while(menos)//boton de menos
      {
         delay_ms(10);
         if(!menos)
         {
            x--;
         }
      }
        
      oled_ajuste();  
        
      while(ajs)//boton de ajuste para regresar
      {
         delay_ms(10);
         if (!ajs)
         {  
            write_eeprom(1,x);//(n de registro, dato)
            return;
         }
      } 
      
   }
}
